#pragma once
#include "../Controller/Network.h"

#include "CustomByteParser.h"
#include "CoreMinimal.h"
#include "UObject/NoExportTypes.h"
#include <Runtime/Networking/Public/Interfaces/IPv4/IPv4Address.h>
#include <Runtime/Sockets/Public/SocketSubsystem.h>
#include <Runtime/Networking/Public/Common/UdpSocketBuilder.h>
#include <Sockets.h>
#include <string>

namespace OWOGame
{
    class UDPNetwork : public Network
    {
    private:
        FSocket* socket = nullptr;
        owoVector<owoString> connectedAddressee;
        ConnectionState state = ConnectionState::Disconnected;

    public:

        virtual std::string Listen(std::string& senderIp) override;
        virtual void Connect(std::string serverIp) override;
        virtual void Send(std::string message) override;
        virtual void SendTo(std::string message, std::string ip) override;
        virtual void Disconnect() override;
        virtual void Initialize() override;
        virtual ConnectionState GetState() override;
        virtual void SetState(ConnectionState state) override;
        virtual owoVector<owoString> GetConnectedAddressee() override;
    };
}
