// Copyright Epic Games, Inc. All Rights Reserved.

using System.IO;
using UnrealBuildTool;

public class OWOIntegration : ModuleRules
{
	public OWOIntegration(ReadOnlyTargetRules Target) : base(Target)
	{
		PCHUsage = ModuleRules.PCHUsageMode.UseExplicitOrSharedPCHs;
		
		PublicIncludePaths.AddRange(
			new string[] {
				// ... add public include paths required here ...
				Path.Combine(ModuleDirectory, "..", "OWOIntegration/Public")
            }
			);
				
		
		PrivateIncludePaths.AddRange(
			new string[] {
				// ... add other private include paths required here ...
				Path.Combine(ModuleDirectory, "..", "OWOIntegration/Private")
            }
			);
			
		
		PublicDependencyModuleNames.AddRange(
			new string[]
			{
				"Core",
				/* ... Manually added ... */
			}
			);
			
		
		PrivateDependencyModuleNames.AddRange(
			new string[]
			{
				"CoreUObject",
				"Engine",
				"Slate",
				"SlateCore",
                "Networking",
                "Sockets",
				 #if WITH_EDITOR
				"UnrealEd",
				 #endif
				// ... add private dependencies that you statically link with here ...	
			}
            );
		
		
		DynamicallyLoadedModuleNames.AddRange(
			new string[]
			{
				// ... add any modules that your module loads dynamically here ...
			}
			);

	   //if (Target.Platform == UnrealTargetPlatform.Win64)
    //        PublicAdditionalLibraries.Add(Path.Combine(ModuleDirectory, "..", "../OWOAPI/win64/OWO.lib"));
    //    else
    //        PublicAdditionalLibraries.Add(Path.Combine(ModuleDirectory, "..", "../OWOAPI/android/libowo.a"));
	   
    }
}
